#ifndef MESH_H
#define MESH_H

#include<QHash>

class SimulationMesh
{
public:
    SimulationMesh(int, int, int, int);
    ~SimulationMesh();
    void simulate_old();
    void simulate();
    int addLink(int, int);
    void updateDist(int from, int to, double distance);
    void updateParameter(QString name, double value); //allows only double parameters for now.
    void updateNodeValues(int nodeidx, double temp, double fuel);

    // public members
    int* nborMatrix;//[NUMNODES*(MAXNBORS+1)];//two-dimensional, with width 'maxnbors+1' and the first column is no. of nbors
    int* numNbors;


    // public accessors
    double getNborDist(int node, int nborNo);
    double getNodeTemp(int node);
    double getNodeFuel(int node);
    bool getNodeIgn(int node);


private:
    double* nborDists;//[NUMNODES*(MAXNBORS+1)];//distances for neighbours in nborMatrix
    double* nodeTemps;//[NUMNODES];
    double* nodeFuels;//[NUMNODES];
    bool* nodeIgn;

    int numNodes;
    int numLinks;
    int maxNbors;
    int numParams;
    QHash<QString, double> parameters;


    // Private methods:
    int addHalfLink(int, int);
};

#endif // MESH_H
