#include "StdAfx.h"
#include "Mesh.h"

Mesh::Mesh(GLint numNodes, GLint* neighbours, GLint numMaxNbors, GLfloat* distances,
		GLfloat* linkDirs, GLint* vertexMap, GLint* nborCounts, GLfloat* fuels)
{
	this->numNodes = numNodes;
	this->neighbours = neighbours;
	this->numMaxNbors = numMaxNbors;
	this->distances = distances;
	this->linkDirs = linkDirs;
	this->vertexMap = vertexMap;
	this->nborCounts = nborCounts;
	this->nodeFuels = fuels;
	nodeTemperatures = new GLfloat[numNodes];
}

Mesh::~Mesh(void)
{
	
	delete[] nodeTemperatures; 
	delete[] nodeFuels;
	delete[] nborCounts;
	delete[] vertexMap;
	delete[] linkDirs;
	delete[] distances;//distances between the neighbours.
	delete[] neighbours;
}

// temperature is typically initialized to a single surrounding temperature
void Mesh::setUniformTemperatures(float temp)
{
	for (int n = 0; n < numNodes; n++)
	{
		nodeTemperatures[n] = temp;
	}
}

void Mesh::setSingleTemperature(int nodeIdx, float temp)
{
	nodeTemperatures[nodeIdx] = temp;
}

