#pragma once

class Mesh
{
// This is mainly a storage class (POD - Plain Old Data structure)
// and so only really need a set of public members.

public:
	Mesh(GLint numNodes,
		GLint* neighbours,
		GLint numMaxNbors,
		GLfloat* distances,
		GLfloat* linkDirs, 
		GLint* vertexMap,
		GLint* nborCounts,
		GLfloat* fuels);
	~Mesh(void);

	GLint numNodes;
	GLint* neighbours;//neighbourMatrix (two-dimensional, with width 'nborwidth' and the first column is no. of nbors)
	GLint numMaxNbors;
	GLfloat* distances;//distances between the neighbours.
	GLfloat* linkDirs; //direction vectors between the neighbours (normalized)
	GLfloat* nodeTemperatures; 
	GLfloat* nodeFuels;
	GLint* vertexMap;
	GLint* nborCounts;

	void setUniformTemperatures(float temp);
	void setSingleTemperature(int nodeIdx, float temp);
};
