#pragma once

#define NUM_VERTEX_BUFFERS 5
#define POSITION_BUFFER 0
#define NORMAL_BUFFER 1
#define GLOW_BUFFER 2
#define DISPL_BUFFER 3
#define TEX_BUFFER 4
class RenderObject
{
// Public members
public:
	//GLenum primitiveType; //Must be GL_TRIANGLE right now
	GLfloat m_modelMatrix[16];
	GLfloat m_normalMatrix[3][3];
	GLuint shaderProgram;
	GLuint vertexArrayObject;
	GLuint vertexBuffersObject[NUM_VERTEX_BUFFERS];
	GLuint texObject;
	GLuint indexBufferObject;
	RenderContext* renderContextp;
	GLint numDrawVerts; // the total number of vertices to be drawn (numFaces * numVertsPrFace)

// Only for this and derived (BurningObject) classes
protected:	
	GLboolean loadShaderProgram(const GLchar* vertexSource, const GLchar* fragmentSource);
	void makeVertexBuffers(GLfloat* vertPos, GLfloat* vertNorm, GLfloat* vertColors, GLfloat* vertTexture, 
		GLfloat* vertexDispl, GLint* facelookuptable, GLint numVertices);
	void initTexture(const char* filename);


// Public methods
public:
	RenderObject(void);
	RenderObject(GLfloat* vertexPositions, GLfloat* vertexNormals, GLfloat* vertexColors, GLfloat* vertexTexcoords,
		GLfloat* vertexDispl, GLint* facelookuptable, GLint numVertices, GLint numDrawVerts, 
		const char* vertShaderFilename, const char* fragShaderFilename, const char* textureFilename);
	~RenderObject(void);
	void reset(void);
	void draw(RenderContext* renderContextp);//void);
	void translate(GLfloat dx, GLfloat dy, GLfloat dz);
	void rotate(GLfloat angle, AXIS axis);
	void scale(GLfloat sx, GLfloat sy, GLfloat sz);

};





