/*******************************************************************
 * This file is for code fragments that I'm not using any more, 
 * but that I want to keep for references or just in case....
 *******************************************************************/


/*
#define ARRAYLENGTH 10
void RenderObject::initTemperatureBuffers(void)
{

	GLchar* programsource = readFile("temperature_kernels.cl", 100000);
    cl_int err;
 
    cl::Context context(
       CL_DEVICE_TYPE_GPU, 
       NULL,
       NULL,
       NULL,
       &err);
   checkErr(err, "Context::Context()");


   GLfloat * outH = new GLfloat[ARRAYLENGTH];
    cl::Buffer outCL(
        context,
        CL_MEM_WRITE_ONLY | CL_MEM_USE_HOST_PTR,
        ARRAYLENGTH*sizeof(GLfloat),
        outH,
        &err);
    checkErr(err, "Buffer::Buffer()");


	cl::vector<cl::Device> devices;
    devices = context.getInfo<CL_CONTEXT_DEVICES>();
    checkErr(
        devices.size() > 0 ? CL_SUCCESS : -1, "devices.size() > 0");

	cl::Program::Sources source(1,std::make_pair(programsource, strlen(programsource)+1));

    cl::Program program(context, source);
    err = program.build(devices,"");
    checkErr(err, "Program::build()");




	cl::Kernel kernel(program, "hello", &err);
    checkErr(err, "Kernel::Kernel()");
 
    err = kernel.setArg(0, outCL);
    checkErr(err, "Kernel::setArg()");


	cl::CommandQueue queue(context, devices[0], 0, &err);
    checkErr(err, "CommandQueue::CommandQueue()");
 

    cl::Event event;
    err = queue.enqueueNDRangeKernel(
        kernel, 
        cl::NullRange,
        cl::NDRange(ARRAYLENGTH),
         cl::NDRange(1, 1), 
        NULL, 
        &event);
    checkErr(err, "ComamndQueue::enqueueNDRangeKernel()");



    event.wait();    
    err = queue.enqueueReadBuffer(
        outCL,
        CL_TRUE,
        0,
        ARRAYLENGTH * sizeof(GLfloat),
        outH);
    checkErr(err, "ComamndQueue::enqueueReadBuffer()");
	for (int i = 0; i < ARRAYLENGTH; i++)
		std::cout << outH[i] << ", ";
	std::cout << std::endl;

}
*/

/*  
// OBS: Requires that shaderProgram has been set/initialized!
void RenderObject::initTriangle(GLfloat width, GLfloat height, GLfloat depth)
{
	checkError("initTriangle 0");
	const int X = 0;
	const int Y = 1;
	const int Z = 2;

	vertices = new GLfloat[9];
    // The quad is centered about the world origin.

	//front quad
    vertices[3*0+X] = 0.0f; //top
    vertices[3*0+Y] = height * 0.5f;
    vertices[3*0+Z] = depth;

    vertices[3*1+X] = -width * 0.5f;//bottom left
    vertices[3*1+Y] = -height * 0.5f;
    vertices[3*1+Z] = depth;

    vertices[3*2+X] = width * 0.5f;//bottom right
    vertices[3*2+Y] = -height * 0.5f;
    vertices[3*2+Z] = depth;


    // Create the vertex array object for the quad.
    //
    // The buffer objects that are to be used by the vertex stage of the GL
    // are collected together to form a vertex array object. All state related
    // to the definition of data used by the vertex processor is encapsulated
    // in a vertex array object.
    //
    // Vertex array objects maintain state. Any required vertex and index
    // buffer objects are created and bound to the vertex array object. Then
    // any vertex shader generic shader input variables are mapped to the
    // vertex data stored in the vertex buffer objects bound to the vertex
    // array object. All of this only needs to be done once when using vertex
    // array objects.
    //
    // When we want to draw the quad we simple bind the vertex array object and
    // then call glDrawElements() to do the drawing. There is no need to define
    // the quad's vertex array format again since that information has already
    // been specified and saved to the vertex array object.
    //
    // See the renderQuad() method to see how vertex array objects are used in
    // practice.

    glGenVertexArrays(1, &vertexArrayObject);
    glBindVertexArray(vertexArrayObject);

	checkError("initTriangle 1");
    // Create the Vertex Buffer Object for the quad.
    
    glGenBuffers(1, &vertexBufferObject);
    glBindBuffer(GL_ARRAY_BUFFER, vertexBufferObject);
    glBufferData(GL_ARRAY_BUFFER, 9*sizeof(GLfloat), vertices, GL_STATIC_DRAW);

	checkError("initTriangle 2");
    // GLSL 1.30 (OpenGL 3.0) deprecates varying and attribute shader
    // variables. These are replaced with used-defined generic vertex and
    // fragment shader input and output variables.
    //
    // Map the generic vertex attributes used by the quad's shader program to
    // the quad's vertex data stored in the vertex buffer object.

    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Position"), 3, GL_FLOAT, GL_FALSE, 0, BUFFER_OFFSET(0));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Position"));
	
	checkError("initTriangle 3");
}


void RenderObject::renderTriangle()// const
{
	checkError("renderTri -1");
    glUseProgram(shaderProgram);
	checkError("renderTri 0");

    // GLSL 1.30 (OpenGL 3.0) deprecates most of the built-in uniform state
    // variables. In GLSL 1.40 (OpenGL 3.1) they have been removed. We now
    // directly supply the projection, view, and model matrices to our shader.
    // OpenGL 3.0 also deprecates fixed-function vertex processing. This means
    // that we also need to calculate the projection, view, and model matrices
    // by ourself.
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ProjectionMatrix"), 1, GL_FALSE, m_projectionMatrix);
	checkError("render 1");
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ViewMatrix"), 1, GL_FALSE, m_viewMatrix);
	checkError("render 2");
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ModelMatrix"), 1, GL_FALSE, m_modelMatrix);
	checkError("render 3");

    glBindVertexArray(vertexArrayObject);
	checkError("render 4");
    glDrawArrays(GL_TRIANGLES, 0, 3);
	checkError("render 5");
	
	//checkError ("renderQuad1");
    //translate(GLfloat(WIN_WIDTH) * 0.3f, GLfloat(WIN_HEIGHT) * 0.3f, 0.0f);
    //glUniformMatrix4fv(glGetUniformLocation(m_quad.shaderProgram, "ModelMatrix"), 1, GL_FALSE, m_modelMatrix);
    //glDrawElements(GL_TRIANGLE_STRIP, sizeof(m_quad.indices) / sizeof(m_quad.indices[0]), GL_UNSIGNED_SHORT, BUFFER_OFFSET(0));

	//checkError ("renderQuad2");
	
    glBindVertexArray(0);

    //glBindTexture(GL_TEXTURE_2D, 0);
    glUseProgram(0);
}


// OBS: Requires that shaderProgram has been set/initialized!
void RenderObject::initTriangle2(GLfloat width, GLfloat height, GLfloat depth)
{
	checkError("initTriangle 0");
	const int X = 0;
	const int Y = 1;
	const int Z = 2;

	vertices = new GLfloat[12];
    // The quad is centered about the world origin.

	//front quad
    vertices[3*0+X] = -width * 0.5f; //top left
    vertices[3*0+Y] = height * 0.5f;
    vertices[3*0+Z] = depth;

    vertices[3*1+X] = -width * 0.5f;//bottom left
    vertices[3*1+Y] = -height * 0.5f;
    vertices[3*1+Z] = depth;

    vertices[3*2+X] = width * 0.5f;//bottom right
    vertices[3*2+Y] = -height * 0.5f;
    vertices[3*2+Z] = depth;

    vertices[3*3+X] = width * 0.5f;//top right
    vertices[3*3+Y] = height * 0.5f;
    vertices[3*3+Z] = depth;
	
	indices = new GLubyte[6];

	indices[0]=0;
	indices[1]=1;
	indices[2]=2;
	indices[3]=2;
	indices[4]=3;
	indices[5]=0;


    // Create the vertex array object for the quad.
    //
    // The buffer objects that are to be used by the vertex stage of the GL
    // are collected together to form a vertex array object. All state related
    // to the definition of data used by the vertex processor is encapsulated
    // in a vertex array object.
    //
    // Vertex array objects maintain state. Any required vertex and index
    // buffer objects are created and bound to the vertex array object. Then
    // any vertex shader generic shader input variables are mapped to the
    // vertex data stored in the vertex buffer objects bound to the vertex
    // array object. All of this only needs to be done once when using vertex
    // array objects.
    //
    // When we want to draw the quad we simple bind the vertex array object and
    // then call glDrawElements() to do the drawing. There is no need to define
    // the quad's vertex array format again since that information has already
    // been specified and saved to the vertex array object.
    //
    // See the renderQuad() method to see how vertex array objects are used in
    // practice.

    glGenVertexArrays(1, &vertexArrayObject);
    glBindVertexArray(vertexArrayObject);

	checkError("initTriangle 1");
    // Create the Vertex Buffer Object for the quad.
    
    glGenBuffers(1, &vertexBufferObject);
    glBindBuffer(GL_ARRAY_BUFFER, vertexBufferObject);
    glBufferData(GL_ARRAY_BUFFER, 12*sizeof(GLfloat), vertices, GL_STATIC_DRAW);
    // Create the Index Buffer Object for the quad.

    glGenBuffers(1, &indexBufferObject);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indexBufferObject);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, 6*sizeof(GLubyte), indices, GL_STATIC_DRAW);

	checkError("initTriangle 2");
    // GLSL 1.30 (OpenGL 3.0) deprecates varying and attribute shader
    // variables. These are replaced with used-defined generic vertex and
    // fragment shader input and output variables.
    //
    // Map the generic vertex attributes used by the quad's shader program to
    // the quad's vertex data stored in the vertex buffer object.

    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Position"), 3, GL_FLOAT, GL_FALSE, 0, BUFFER_OFFSET(0));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Position"));
	
	checkError("initTriangle 3");
}


void RenderObject::renderTriangle2()// const
{
	checkError("renderTri -1");
    glUseProgram(shaderProgram);
	checkError("renderTri 0");

    // GLSL 1.30 (OpenGL 3.0) deprecates most of the built-in uniform state
    // variables. In GLSL 1.40 (OpenGL 3.1) they have been removed. We now
    // directly supply the projection, view, and model matrices to our shader.
    // OpenGL 3.0 also deprecates fixed-function vertex processing. This means
    // that we also need to calculate the projection, view, and model matrices
    // by ourself.
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ProjectionMatrix"), 1, GL_FALSE, m_projectionMatrix);
	checkError("render 1");
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ViewMatrix"), 1, GL_FALSE, m_viewMatrix);
	checkError("render 2");
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ModelMatrix"), 1, GL_FALSE, m_modelMatrix);
	checkError("render 3");

    glBindVertexArray(vertexArrayObject);
	checkError("render 4");
    //glDrawArrays(GL_TRIANGLES, 0, 3);
    glDrawElements(GL_TRIANGLES, 6,GL_UNSIGNED_BYTE, BUFFER_OFFSET(0));
	checkError("render 5");
	
	//checkError ("renderQuad1");
    //translate(GLfloat(WIN_WIDTH) * 0.3f, GLfloat(WIN_HEIGHT) * 0.3f, 0.0f);
    //glUniformMatrix4fv(glGetUniformLocation(m_quad.shaderProgram, "ModelMatrix"), 1, GL_FALSE, m_modelMatrix);
    //glDrawElements(GL_TRIANGLE_STRIP, sizeof(m_quad.indices) / sizeof(m_quad.indices[0]), GL_UNSIGNED_SHORT, BUFFER_OFFSET(0));

	//checkError ("renderQuad2");
	
    glBindVertexArray(0);

    //glBindTexture(GL_TEXTURE_2D, 0);
    glUseProgram(0);
}


// OBS: Requires that shaderProgram has been set/initialized!
void RenderObject::initCube(GLfloat width, GLfloat height, GLfloat depth)
{
	checkError("initcube 0");
	const int X = 0;
	const int Y = 1;
	const int Z = 2;

	vertices = new GLfloat[24];
    // The quad is centered about the world origin.

	//front quad
    vertices[3*0+X] = -width * 0.5f; //top left
    vertices[3*0+Y] = height * 0.5f;
    vertices[3*0+Z] = depth * 0.5f;

    vertices[3*1+X] = -width * 0.5f;//bottom left
    vertices[3*1+Y] = -height * 0.5f;
    vertices[3*1+Z] = depth * 0.5f;

    vertices[3*2+X] = width * 0.5f;//top right
    vertices[3*2+Y] = height * 0.5f;
    vertices[3*2+Z] = depth * 0.5f;
    
    vertices[3*3+X] = width * 0.5f;//bottom right
    vertices[3*3+Y] = -height * 0.5f;
    vertices[3*3+Z] = depth * 0.5f;

	//back quad
    vertices[3*4+X] = -width * 0.5f;//top left
    vertices[3*4+Y] = height * 0.5f;
    vertices[3*4+Z] = -depth * 0.5f;

    vertices[3*5+X] = -width * 0.5f;//bottom left
    vertices[3*5+Y] = -height * 0.5f;
    vertices[3*5+Z] = -depth * 0.5f;

    vertices[3*6+X] = width * 0.5f;//top right
    vertices[3*6+Y] = height * 0.5f;
    vertices[3*6+Z] = -depth * 0.5f;
    
    vertices[3*7+X] = width * 0.5f;//bottom right
    vertices[3*7+Y] = -height * 0.5f;
    vertices[3*7+Z] = -depth * 0.5f;
    
    
	indices = new GLubyte[36];

	//front quad:
	indices[0]=0;
	indices[1]=1;
	indices[2]=3;
	indices[3]=3;
	indices[4]=2;
	indices[5]=0;
	//back quad
	indices[6]=6;
	indices[7]=7;
	indices[8]=5;
	indices[9]=5;
	indices[10]=4;
	indices[11]=6;
	//left quad
	indices[12]=4;
	indices[13]=5;
	indices[14]=1;
	indices[15]=1;
	indices[16]=0;
	indices[17]=4;
	//right quad
	indices[18]=2;
	indices[19]=3;
	indices[20]=7;
	indices[21]=7;
	indices[22]=6;
	indices[23]=2;
	//top quad
	indices[24]=4;
	indices[25]=0;
	indices[26]=2;
	indices[27]=2;
	indices[28]=6;
	indices[29]=4;
	//bottom quad
	indices[30]=1;
	indices[31]=5;
	indices[32]=7;
	indices[33]=7;
	indices[34]=3;
	indices[35]=1;



    // Create the vertex array object for the quad.
    //
    // The buffer objects that are to be used by the vertex stage of the GL
    // are collected together to form a vertex array object. All state related
    // to the definition of data used by the vertex processor is encapsulated
    // in a vertex array object.
    //
    // Vertex array objects maintain state. Any required vertex and index
    // buffer objects are created and bound to the vertex array object. Then
    // any vertex shader generic shader input variables are mapped to the
    // vertex data stored in the vertex buffer objects bound to the vertex
    // array object. All of this only needs to be done once when using vertex
    // array objects.
    //
    // When we want to draw the quad we simple bind the vertex array object and
    // then call glDrawElements() to do the drawing. There is no need to define
    // the quad's vertex array format again since that information has already
    // been specified and saved to the vertex array object.
    //
    // See the renderQuad() method to see how vertex array objects are used in
    // practice.

    glGenVertexArrays(1, &vertexArrayObject);
    glBindVertexArray(vertexArrayObject);

	checkError("initcube 1");
    // Create the Index Buffer Object for the quad.

    glGenBuffers(1, &indexBufferObject);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indexBufferObject);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, 36*sizeof(GLubyte), indices, GL_STATIC_DRAW);

	checkError("initcube 2");
    // Create the Vertex Buffer Object for the quad.
    
    glGenBuffers(1, &vertexBufferObject);
    glBindBuffer(GL_ARRAY_BUFFER, vertexBufferObject);
    glBufferData(GL_ARRAY_BUFFER, 24*sizeof(GLfloat), vertices, GL_STATIC_DRAW);

	checkError("initcube 3");
    // GLSL 1.30 (OpenGL 3.0) deprecates varying and attribute shader
    // variables. These are replaced with used-defined generic vertex and
    // fragment shader input and output variables.
    //
    // Map the generic vertex attributes used by the quad's shader program to
    // the quad's vertex data stored in the vertex buffer object.

    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Position"), 3, GL_FLOAT, GL_FALSE, 0, BUFFER_OFFSET(0));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Position"));
	
	checkError("initcube 4");
}



void RenderObject::renderCube()// const
{
	checkError("render -1");
    glUseProgram(shaderProgram);
	checkError("render 0");

    // GLSL 1.30 (OpenGL 3.0) deprecates most of the built-in uniform state
    // variables. In GLSL 1.40 (OpenGL 3.1) they have been removed. We now
    // directly supply the projection, view, and model matrices to our shader.
    // OpenGL 3.0 also deprecates fixed-function vertex processing. This means
    // that we also need to calculate the projection, view, and model matrices
    // by ourself.
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ProjectionMatrix"), 1, GL_FALSE, renderContextp->m_projectionMatrix);
	checkError("render 1");
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ViewMatrix"), 1, GL_FALSE, renderContextp->m_viewMatrix);
	checkError("render 2");
    glUniformMatrix4fv(glGetUniformLocation(shaderProgram, "ModelMatrix"), 1, GL_FALSE, m_modelMatrix);
	checkError("render 3");

    glBindVertexArray(vertexArrayObject);
	checkError("render 4");
    //glDrawElements((GLenum) GL_QUADS, sizeof(indices) / sizeof(indices[0]),(GLenum)  GL_UNSIGNED_BYTE, BUFFER_OFFSET(0));sizeof cannot be used with dynamically typed arrays!
    glDrawElements(GL_TRIANGLES, 36,GL_UNSIGNED_BYTE, BUFFER_OFFSET(0));
	checkError("render 5");
	
	//checkError ("renderQuad1");
    //translate(GLfloat(WIN_WIDTH) * 0.3f, GLfloat(WIN_HEIGHT) * 0.3f, 0.0f);
    //glUniformMatrix4fv(glGetUniformLocation(m_quad.shaderProgram, "ModelMatrix"), 1, GL_FALSE, m_modelMatrix);
    //glDrawElements(GL_TRIANGLE_STRIP, sizeof(m_quad.indices) / sizeof(m_quad.indices[0]), GL_UNSIGNED_SHORT, BUFFER_OFFSET(0));

	//checkError ("renderQuad2");
	
    glBindVertexArray(0);

    //glBindTexture(GL_TEXTURE_2D, 0);
    glUseProgram(0);
}

*/



/*
void RenderObject::loadData2(GLfloat* in_data, GLint numVertices, GLint numColors, GLubyte* in_indices, GLint numIndices, GLenum in_primitiveType)
{
	
	primitiveType = in_primitiveType;
	elementCount = numIndices/2;

	vindices = new GLubyte[numIndices];
	vertices = new GLfloat[3 * (numVertices + numColors)];
	memcpy(vindices, in_indices, sizeof(GLubyte) * numIndices);
	memcpy(vertices, in_data, sizeof(GLfloat) * 3 * (numVertices + numColors));

	glGenVertexArrays(1, &vertexArrayObject);
    glBindVertexArray(vertexArrayObject);

	checkError("loadData 1");
    // Create the Index Buffer Object for the quad.

    glGenBuffers(1, &vindexBufferObject);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vindexBufferObject);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(GLubyte) * numIndices, vindices, GL_STATIC_DRAW);

	checkError("loadData 2");
    // Create the Vertex Buffer Object for the quad.
    
    glGenBuffers(1, &vertexBufferObject);
    glBindBuffer(GL_ARRAY_BUFFER, vertexBufferObject);
    glBufferData(GL_ARRAY_BUFFER, sizeof(GLfloat) * 3 * (numVertices + numColors), vertices, GL_STATIC_DRAW);

	checkError("loadData 3");
    // GLSL 1.30 (OpenGL 3.0) deprecates varying and attribute shader
    // variables. These are replaced with used-defined generic vertex and
    // fragment shader input and output variables.
    //
    // Map the generic vertex attributes used by the quad's shader program to
    // the quad's vertex data stored in the vertex buffer object.

    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Position"), 3, GL_FLOAT, GL_FALSE, sizeof(GLubyte), BUFFER_OFFSET(0));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Position"));

	checkError("loadData 6");
    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Color"), 3, GL_FLOAT, GL_FALSE, sizeof(GLubyte), BUFFER_OFFSET(sizeof(GLubyte)));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Color"));
	
	checkError("loadData 7");

}

void RenderObject::loadData(GLfloat* in_vertices, GLint numVertices, GLubyte* in_vindices, \
							GLfloat* in_colors, GLint numColors, GLubyte* in_cindices, \
							GLint numIndices, GLenum in_primitiveType)
{
	
	primitiveType = in_primitiveType;
	elementCount = numIndices;

	vindices = new GLubyte[numIndices];
	vertices = new GLfloat[3* numVertices];
	cindices = new GLubyte[numIndices];
	colors = new GLfloat[3* numColors];
	memcpy(vindices, in_vindices, sizeof(GLubyte) * numIndices);
	memcpy(vertices, in_vertices, sizeof(GLfloat) * 3 * numVertices);
	memcpy(cindices, in_cindices, sizeof(GLubyte) * numIndices);
	memcpy(colors, in_colors, sizeof(GLfloat) * 3 * numColors);

	glGenVertexArrays(1, &vertexArrayObject);
    glBindVertexArray(vertexArrayObject);

	checkError("loadData 1");
    // Create the Index Buffer Object for the quad.

    glGenBuffers(1, &vindexBufferObject);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vindexBufferObject);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(GLubyte) * numIndices, vindices, GL_STATIC_DRAW);

	checkError("loadData 2");
    // Create the Vertex Buffer Object for the quad.
    
    glGenBuffers(1, &vertexBufferObject);
    glBindBuffer(GL_ARRAY_BUFFER, vertexBufferObject);
    glBufferData(GL_ARRAY_BUFFER, sizeof(GLfloat) * 3 * numVertices, vertices, GL_STATIC_DRAW);

	checkError("loadData 3");
    // GLSL 1.30 (OpenGL 3.0) deprecates varying and attribute shader
    // variables. These are replaced with used-defined generic vertex and
    // fragment shader input and output variables.
    //
    // Map the generic vertex attributes used by the quad's shader program to
    // the quad's vertex data stored in the vertex buffer object.

    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Position"), 3, GL_FLOAT, GL_FALSE, 0, BUFFER_OFFSET(0));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Position"));

	checkError("loadData 4");
	// Do the same for colordata
    glGenBuffers(1, &cindexBufferObject);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, cindexBufferObject);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(GLubyte) * numIndices, cindices, GL_STATIC_DRAW);

	checkError("loadData 5");
    glGenBuffers(1, &colorBufferObject);
    glBindBuffer(GL_ARRAY_BUFFER, colorBufferObject);
    glBufferData(GL_ARRAY_BUFFER, sizeof(GLfloat) * 3 * numColors, colors, GL_STATIC_DRAW);

	checkError("loadData 6");
    glVertexAttribPointer(glGetAttribLocation(shaderProgram, "Color"), 3, GL_FLOAT, GL_FALSE, 0, BUFFER_OFFSET(0));
    glEnableVertexAttribArray(glGetAttribLocation(shaderProgram, "Color"));
	
	checkError("loadData 7");

}
*/

/* A simple function that will read a file into an allocated char pointer buffer */
char* filetobuf_old(char* file)
{
	FILE *fptr;
    long length;
    char *buf;

    fptr = fopen(file, "r"); /* Open file for reading */
    if (!fptr) /* Return NULL on failure */
        return NULL;
    fseek(fptr, 0, SEEK_END); /* Seek to the end of the file */
    length = ftell(fptr); /* Find out how many bytes into the file we are */
    buf = (char*)malloc(length + 1); /* Allocate a buffer for the entire length of the file plus a null terminator */
    fseek(fptr, 0, SEEK_SET); /* Go back to the beginning of the file */
    fread(buf, length, 1, fptr); /* Read the contents of the file in to the buffer */
    fclose(fptr); /* Close the file */
    buf[length] = 0; /* Null terminator */

    return buf; /* Return the buffer */
}


void RenderContext::ortho2D(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat nearVal, GLfloat farVal)
{
    // Build a 2D orthographic projection matrix.
    // This is the same matrix used by gluOrtho2D() and glOrtho().

    //const GLfloat nearVal = -1.0f;
    //const GLfloat farVal = 1.0f;

    GLfloat tx = -(right + left) / (right - left);
    GLfloat ty = -(top + bottom) / (top - bottom);
    GLfloat tz = -(farVal + nearVal) / (farVal - nearVal);

    m_projectionMatrix[0] = (2.0f / (right - left));
    m_projectionMatrix[1] = 0.0f;
    m_projectionMatrix[2] = 0.0f;
    m_projectionMatrix[3] = 0.0f;

    m_projectionMatrix[4] = 0.0f;
    m_projectionMatrix[5] = (2.0f / (top - bottom));
    m_projectionMatrix[6] = 0.0f;
    m_projectionMatrix[7] = 0.0f;

    m_projectionMatrix[8] = 0.0f;
    m_projectionMatrix[9] = 0.0f;
    m_projectionMatrix[10] = (-2.0f / (farVal - nearVal));
    m_projectionMatrix[11] = 0.0f;

    m_projectionMatrix[12] = tx;
    m_projectionMatrix[13] = ty;
    m_projectionMatrix[14] = tz;
    m_projectionMatrix[15] = 1.0f;
}

void RenderContext::perspective_old(GLfloat fov, GLfloat aspect, GLfloat zNear, GLfloat zFar)
{
  const GLfloat h = 1.0f/tan(fov*PI_OVER_360);
  GLfloat neg_depth = zNear-zFar;

  m_projectionMatrix[0] = h / aspect;
  m_projectionMatrix[1] = 0;
  m_projectionMatrix[2] = 0;
  m_projectionMatrix[3] = 0;

  m_projectionMatrix[4] = 0;
  m_projectionMatrix[5] = h;
  m_projectionMatrix[6] = 0;
  m_projectionMatrix[7] = 0;

  m_projectionMatrix[8] = 0;
  m_projectionMatrix[9] = 0;
  m_projectionMatrix[10] = (zFar + zNear)/neg_depth;
  m_projectionMatrix[11] = -1;

  m_projectionMatrix[12] = 0;
  m_projectionMatrix[13] = 0;
  m_projectionMatrix[14] = 2.0f*(zNear*zFar)/neg_depth;
  m_projectionMatrix[15] = 0;
}


void ObjData::makeLookupTables_old(const VertexIndices* rawVertexLookup)
{
	VertexIndices* tempVertexLookup = new VertexIndices[elementCounts.numFacesIndices]; //there can be max the same number of vertices as indices, which means no vertex is reused.
	faceLookup = new GLuint[elementCounts.numFacesIndices];
	memset(faceLookup, 0, elementCounts.numFacesIndices * sizeof(GLuint));
	GLuint numVertices = elementCounts.numPositions;
	VertexIndices emptyvertex;
	emptyvertex.colorIdx = -1;
	emptyvertex.normalIdx = -1;
	emptyvertex.positionIdx = -1;
	emptyvertex.texIdx = -1;
	emptyvertex.nextPointer = 0;

	// Mark all entries in the table as free.
	for (GLuint i = 0; i < elementCounts.numFacesIndices; i++)
	{
		tempVertexLookup[i] = emptyvertex;
	}
	

	// Making a linked list sorted on vertex positions. 
	// The overflow vertices are stored at the end of the lookup table.
	for (GLuint i = 0; i < elementCounts.numFacesIndices; i++)
	{
		// check if the sorted position is free
		if (vertexEqual(tempVertexLookup[rawVertexLookup[i].positionIdx], emptyvertex))
		{
			// add the indices to the vertex lookup table
			tempVertexLookup[rawVertexLookup[i].positionIdx] = rawVertexLookup[i];
			// add the index to the faceLookup, and continue
			faceLookup[i] = rawVertexLookup[i].positionIdx;
			continue;
		}
		// check if the lookup-table already contains this vertex,
		// by following pointers through the table.
		GLboolean found = GL_FALSE;
		GLint next = rawVertexLookup[i].positionIdx;//tempVertexLookup[rawVertexLookup[i].positionIdx].nextPointer;
		GLint last = 0;
		do{
			if(vertexEqual(tempVertexLookup[next], rawVertexLookup[i]))
			{
				found = GL_TRUE;
				faceLookup[i] = next;
				break;
			}//else:
			last = next;
			next = tempVertexLookup[last].nextPointer;
		}while (next != 0);
		if (found) continue;
		// if none of the above, append to the end of the lookuptable
		tempVertexLookup[numVertices] = rawVertexLookup[i];
		faceLookup[i] = numVertices;
		//update last next-pointer
		tempVertexLookup[last].nextPointer = numVertices;
		numVertices++;	
	}
	elementCounts.numVertices = numVertices;
	vertexLookup = new VertexIndices[numVertices];
	memcpy(vertexLookup, tempVertexLookup, numVertices * sizeof(VertexIndices));
	std::cout << "Created " << elementCounts.numVertices << " vertices." << std::endl;
	
	//Debug: for (int i = 0; i < 100; i++)
	//Debug: {
	//Debug: 	std::cout << "actual position: " << vertexLookup[i].positionIdx << ", actual next: " << vertexLookup[i].nextPointer << std::endl;
	//Debug: }
	
	delete [] tempVertexLookup;
}


#define VERTS_PR_FACE 3
#define MAX_NEIGHBOURS 50
#define TEMPNBORS(row,col) tempnbors[((row)*tempnborswidth)+(col)]
#define NBORS(row,col) nbors[((row)*nborswidth)+(col)]
// Fills out the neighbour matrix 'nbors'.
// NB: The first column contains number of neighbours for each vertex!
void ObjData::makeNeighbourMatrix_old()//const VertexIndices* rawVertexLookup) This should really be made from faceLookup, rather than depend on the temporary rawVertexLookup
{
	int errcount = 0;
	const int errthresh = 10;
	GLuint nboridx = 0;
	GLuint thisidx = 0;
	GLuint max_nbors_actual = 0;
	const GLuint tempnborswidth = MAX_NEIGHBOURS+1;
	GLuint* tempnbors = new GLuint[elementCounts.numPositions*tempnborswidth];
	memset(tempnbors, 0, elementCounts.numPositions*tempnborswidth*sizeof(GLuint)); //initialize tempnbors to zero. Ensures all vertices start with zero neighbours
	for (GLuint f = 0; f < (elementCounts.numFacesIndices-VERTS_PR_FACE); f+= VERTS_PR_FACE )//for each face
	{
		//for each vertex of the current face
		for (int v = 0; v < VERTS_PR_FACE; v++)
		{
			thisidx = faceLookup[f+v];// rawVertexLookup[f+v].positionIdx;
			//for each of the current vertex' neighbours
			for (int n = 1; n < VERTS_PR_FACE; n++)
			{
				nboridx = faceLookup[f+((v+n)%VERTS_PR_FACE)];//rawVertexLookup[f+((v+n)%VERTS_PR_FACE)].positionIdx;
				GLboolean addnbor = GL_TRUE;
				// check if this-vertex and nbor-vertex is the same (why does this happen??)
				if (thisidx == nboridx)
				{
					addnbor = GL_FALSE;
					if(errcount <= errthresh){
						std::cout << "Warning: Vertex " << thisidx << \
							" met itself as a neighbour. It will not be added to it's own nborlist." << std::endl;
						errcount++;
					}
				}
				//check if neighbours already
				for (GLuint i = 1; i <= TEMPNBORS(thisidx,0); i++)//nbor[idx][0] holds the current number of neighbours for vertex no. 'idx'
				{
					if(TEMPNBORS(thisidx,i) == nboridx){
						// already neighbours; break and dont add
						addnbor = GL_FALSE;
						break;
					}
				}
				if (addnbor)
				{
					TEMPNBORS(thisidx,0)++; //update vertex' number of neighbours.
					//update max_nbors_actual
					if (TEMPNBORS(thisidx, 0) > max_nbors_actual)
						max_nbors_actual = TEMPNBORS(thisidx, 0);
					// error check
					if (TEMPNBORS(thisidx,0) >= MAX_NEIGHBOURS)
					{
						std::cerr << "Warning: Vertex " << thisidx << \
							" hit MAX_NEIGHBOURS. New neighbours will overwrite the old ones!" << std::endl;
						TEMPNBORS(thisidx,0) = MAX_NEIGHBOURS; //Makes holds the number of neighbours at max
					}
					TEMPNBORS(thisidx,TEMPNBORS(thisidx,0)) = nboridx; //add the neighbour
				}
			}
		}
	}
	// The neighbourmatrix is to be stored in gpu-memory, so it shouldn't be larger than it has to (though we still want to keep it square).
	nborswidth = max_nbors_actual + 1;
	nbors = new GLuint[elementCounts.numPositions*nborswidth];
	for (int row = 0; row < elementCounts.numPositions; row++)
		for (int col = 0; col < nborswidth; col++)
			NBORS(row,col) = TEMPNBORS(row,col);
	// Now we've copied the data into the smaller nbors-table, we can delete tempnbors.
	delete [] tempnbors;
	// DEBUG: Print out a some random neighbours for testing.
	const GLuint testpos = elementCounts.numPositions/6;
	const GLuint testnumbers = max_nbors_actual;
	std::cout << "Random nbors-test:" << std::endl \
		<< "Vertex no. " << testpos \
		<< " has " << NBORS(testpos,0) << " neighbours, " \
		<< "and the first " << testnumbers << " are:" << std::endl;
	for (int i = 1; i <= testnumbers; i++)
	{
		std::cout << NBORS(testpos, i) << ", ";
	}
	std::cout << std::endl;
	std::cout << "Nborswidth is: " << nborswidth << std::endl;

}


void ObjData::makeDistMatrix_old(void)
{
	std::cout << "Making the distances matrix... ";
	distances = new GLfloat[elementCounts.numPositions*nborswidth];
	int errcount = 0;
	const int errthresh = 10;

	//for each vertex
	for (int i = 0; i < elementCounts.numPositions; i++)
	{
		//for each of the vertex' neighbours
		for (int j = 1; j <= nbors[i*nborswidth]; j++)
		{
			int nvertidx = nbors[i*nborswidth + j];
			distances[i*nborswidth + j] = sqrtf(
				powf((vertPositions[i].x - vertPositions[nvertidx].x), 2) + 
				powf((vertPositions[i].y - vertPositions[nvertidx].y), 2) + 
				powf((vertPositions[i].z - vertPositions[nvertidx].z), 2)
				);
			if (errcount < errthresh && distances[i*nborswidth + j] <= 0.000001)
			{
				errcount++;
				std::cout << "Warning: Very short distance between neighbours " << \
					i << " and " << nvertidx << ": " << distances[i*nborswidth + j];
				if (errcount >= 10)
					std::cout << "Warning! More than " << errthresh << "errors! Skipping any remaining errors." << std::endl;
			}

		}

	}

	std::cout << "... done!" << std::endl;

	const GLuint testpos = elementCounts.numPositions/6;
	const GLuint testnumbers = nborswidth - 1;
	std::cout << "Random test:" << std::endl \
		<< "Vertex no. " << testpos \
		<< " has " << nbors[testpos*nborswidth] << " neighbours, " \
		<< "and the distances to the first " << testnumbers << " are:" << std::endl;
	for (int i = 1; i <= testnumbers; i++)
	{
		std::cout << distances[testpos*nborswidth + i] << ", ";
	}
	std::cout << std::endl;
}


// Courtesy of Nate Robins, 1997, 2000 - glm.cpp (heavily modified)
void ObjData::setElementCountsFromObj(std::ifstream* instream, int maxLineLength)
{

	numVertsPrFace = 3; // only supporting triangles for now.
	
	char* line = new char[maxLineLength];

	numPositions = numNormals = numColors = numTexCoords = \
		numVertices = numFaces = 0;
	// First pass: find number of verts, normals and so on:
	while(!instream->eof()) {
		instream->getline(line, maxLineLength);
		switch(line[0]) {
			case '#':               // comment
            break;
			case 'v':               // v, vn, vt
				switch(line[1]) {
					case ' ':          // vertex
						numPositions++;
						break;
					case 'n':           // normal
						numNormals++;
						break;
					case 't':           // texcoord
						numTexCoords++;
						break;
					default:
						std::cerr << "getObjCounts(): Unknown token '" << line[1] << "' in '" \
							<< line << "'." << std::endl;
						exit(1);
						break;
				}
            break;
            case 'm': // material
                //fgets(buf, sizeof(buf), file);
                //sscanf(buf, "%s %s", buf, buf);
                //model->mtllibname = strdup(buf);
                //glmReadMTL(model, buf);
                break;
            case 'u'://use material
                break;
            case 'g':               // group
                //sscanf(buf, "%s", buf);
                //group = glmAddGroup(model, buf);
                break;
            case 'f':               // face
				/* Don't know the point of this... Probably to account for named grouping of vertices
                v = n = t = 0;
                fscanf(file, "%s", buf);
                // can be one of %d, %d//%d, %d/%d, %d/%d/%d %d//%d
                if (strstr(buf, "//")) {
                    // v//n
                    sscanf(buf, "%d//%d", &v, &n);
                    fscanf(file, "%d//%d", &v, &n);
                    fscanf(file, "%d//%d", &v, &n);
                    numtriangles++;
                    group->numtriangles++;
                    while(fscanf(file, "%d//%d", &v, &n) > 0) {
                        numtriangles++;
                        group->numtriangles++;
                    }
                } else if (sscanf(buf, "%d/%d/%d", &v, &t, &n) == 3) {
                    // v/t/n
                    fscanf(file, "%d/%d/%d", &v, &t, &n);
                    fscanf(file, "%d/%d/%d", &v, &t, &n);
                    numtriangles++;
                    group->numtriangles++;
                    while(fscanf(file, "%d/%d/%d", &v, &t, &n) > 0) {
                        numtriangles++;
                        group->numtriangles++;
                    }
                } else if (sscanf(buf, "%d/%d", &v, &t) == 2) {
                    // v/t
                    fscanf(file, "%d/%d", &v, &t);
                    fscanf(file, "%d/%d", &v, &t);
                    numtriangles++;
                    group->numtriangles++;
                    while(fscanf(file, "%d/%d", &v, &t) > 0) {
                        numtriangles++;
                        group->numtriangles++;
                    }
                } else {
                    // v
                    fscanf(file, "%d", &v);
                    fscanf(file, "%d", &v);
                    numtriangles++;
                    group->numtriangles++;
                    while(fscanf(file, "%d", &v) > 0) {
                        numtriangles++;
                        group->numtriangles++;
                    }
                }
				*/
				numFaces++;
				//Remember that triangles can be grouped...
                break;
                
            default:
                break;
		}
  
	}
	delete[] line;
	std::cout << "Found counts: " << std::endl \
		<< numPositions <<" pos, " \
		<< numNormals << " norms, " \
		<< numTexCoords << " texcoords, " \
		<< numFaces << " faces." << std::endl;
	std::cout << "Correct for tree.obj is:" << std::endl \
		<< "35819 pos (35805 for tree_corr), 39376 norms, 37827 texcoords, " << 235602/3 << " faces." << std::endl;
}

// UpdateColors cl-kernel when I used pointers instead of offsets for mapping
__kernel void updatecolors(__global float * readtemps, __global float * fuel, __global int * mapping, 
	__global float * colors)
{
	size_t tid = get_global_id(0);

	unsigned int next = tid;
	unsigned int coloridx = 0;
	float color0 = 0.9; 
	float color1 = 0.1; 
	float color2 = 0.1;
	if (fuel[tid] < -0.01)
	{
		do{
			coloridx = 3*(next);
			next = mapping[2*next+1];
			colors[coloridx+0] = color2;
			colors[coloridx+1] = color1;
			colors[coloridx+2] = color0;
		}while(next != 0);
	} else if ((readtemps[tid] - t_ignite) > -1.0)
	{
		do{
			coloridx = 3*(next);
			next = mapping[2*next+1];
			colors[coloridx+0] = color0;
			colors[coloridx+1] = color1;
			colors[coloridx+2] = color2;
		}while(next != 0);
	} else {
		do{
			coloridx = 3*(next);
			next = mapping[2*next+1];
			colors[coloridx+0] = color1;
			colors[coloridx+1] = color0;
			colors[coloridx+2] = color2;
		}while(next != 0);
	}
}



GLfloat* ObjData::getVertexdata(void)
{
	GLfloat* vertexData = new GLfloat[numVertices*NUM_3VECS_PR_VERT*3];
	int i = 0;
	for (unsigned int pos = 0; pos < vertPositions.size(); pos++)
	{
		for (std::vector<VertexDataPointers>::iterator vert = vertices[pos].begin();
			vert != vertices[pos].end(); ++vert)
		{
			int norm = vert->normalIdx;
			int tex = vert->texIdx;
			int col = vert->colorIdx;
			// Add positions
			vertexData[i++] = vertPositions[pos].x;
			vertexData[i++] = vertPositions[pos].y;
			vertexData[i++] = vertPositions[pos].z;
			// Add normals
			vertexData[i++] = vertNormals[norm].x;
			vertexData[i++] = vertNormals[norm].y;
			vertexData[i++] = vertNormals[norm].z;
			// Add texture coords
			vertexData[i++] = vertTexture[tex].x;
			vertexData[i++] = vertTexture[tex].y;
			vertexData[i++] = vertTexture[tex].z;
			// Add colors
			vertexData[i++] = vertColors[col].x;
			vertexData[i++] = vertColors[col].y;
			vertexData[i++] = vertColors[col].z;
		}
	}

	if (i != (numVertices*NUM_3VECS_PR_VERT*3))
		std::cout << "WARNING: ObjData::getVertexdata() did not find the right amount of vertex data!" << std::endl;

	return vertexData;

}

/******************************************************************************************
 *    temperature kernels (minus color kernel) before I converted to speed based model    *
 ******************************************************************************************/

// Constant parameters:
const float t_ignite = 500.0;
const float fireTemp = 10000.0;
const float tempScaling = 0.01;//0.001;
const float airScaling = 0.05;
const float fuelScaling = 0.0001;//0.00001;
const float distScaling = 2.0;
const float airTemp = 1.0;
const float maxtemp = 10000.0;
const float maxfuel= 10000.0;
const float minfuel= 0.0;
const float fuelthresh = 0.000001;
const float displScaling = 0.5;

__kernel void updatetemps(__global float * readtemps, __global float * writetemps, 
	__global float * fuel, const unsigned int nborswidth, __global int * nbors, 
	__global float * distances, __global int * nborcounts, const float deltaT)
{
    size_t tid = get_global_id(0);
	int numnbors = nborcounts[tid];
	float surroundTemp = 0.0;
	float surroundAirTemp = 0.0;
	float d = 0.0;
	
	// accumulate all neighbours' temperatures, wheighted on distance, to tempsum.
    for (int i = 0; i < numnbors; i++)
    {
		d = 1.0 + (distScaling * distances[tid*nborswidth + i]);
		d = d*d;
		surroundTemp += (readtemps[nbors[tid*nborswidth + i]] - readtemps[tid]) / d; //*d;
	}
	
	//surroundTemp = tempScaling * deltaT * surroundTemp; // (convert_float(numnbors)+1.0);
	writetemps[tid] = surroundTemp + readtemps[tid];

	// if tempsum > t_ignite, and there's fuel left, the vertex is on fire
	if (
		((t_ignite - writetemps[tid]) < 2.0) && \
		(fuel[tid] > -fuelthresh))
	{
		surroundAirTemp = (fireTemp - readtemps[tid]);
		fuel[tid] -= (deltaT * fuelScaling);//writetemps[tid] * 
	// else, just update temperature to gjennomsnitt
	} else {
		surroundAirTemp = (airTemp - readtemps[tid]);
	}
	writetemps[tid] = readtemps[tid] + ((surroundTemp*tempScaling) + (surroundAirTemp * airScaling) * deltaT);

	if (writetemps[tid] > maxtemp)
	{
		writetemps[tid] = maxtemp;
	}
	if (writetemps[tid] < -maxtemp)
	{
		writetemps[tid] = -maxtemp;
	}
	if (fuel[tid] > maxfuel)
	{
		fuel[tid]=maxfuel;
	}
	if (fuel[tid] < minfuel)
	{
		fuel[tid] = minfuel;
	}
    
}

__kernel void copybacktemps(__global float * readtemps, __global float * writetemps)
{
	size_t tid = get_global_id(0);
	readtemps[tid] = writetemps[tid];


}