// ogl3_testX.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#define BUFFER_OFFSET(bytes) ((GLubyte*) NULL + (bytes))
#define WIN_HEIGHT 800
#define WIN_WIDTH 800
#define OPENGL_MINOR_VERSION 1
#define CUBE_WIDTH 20
#define CUBE_HEIGHT 20
#define CUBE_DEPTH 20

RenderContext* ctxt;
BurningObject* tree;
//RenderObject* tree;


inline void drawFps(GLfloat deltat)
{
	static GLfloat time = 0.0f;
	GLfloat fps = 0;
	const GLint updateinterval = 5000; // how many ms between each fps-printout

	time += deltat;

	if (time >= updateinterval) {
		fps = 1000.0f/deltat;
		std::cout << "Time: " << time << "ms, DeltaT: " << deltat << "ms, FPS: " << fps << std::endl;
	 	time = 0.0f;
	}

}

void display(void)
{
	static GLuint fuse = 0;
	static GLfloat rotationX = 0.0f;
	static GLfloat rotationY = 0.0f;
	GLint time;
	static GLint frame=0,timebase=0;
	static GLfloat deltaT = 0.0f; //need to set this to a sane value...
	const GLint updateinterval = 5; //ms
	checkError("draw 0");

	time=glutGet(GLUT_ELAPSED_TIME);

	// Update deltaT: NB: can't update deltaT before one ms has passed.	
	frame++;
	if (time - timebase >= updateinterval) {
		deltaT = float(time-timebase)/float(frame);
		//std::cout << "Test frames: " << frame << ", deltaT: " << deltaT << std::endl;
	 	timebase = time;		
		frame = 0;
	}
	
	drawFps(deltaT);

	fuse += 1;
	//if (fuse > 10)
	//{
		tree->updateTemperatures(deltaT);
		fuse = 0;
	//}

	rotationY += 0.05f*deltaT;
	//rotationY = 230;
	if (rotationY > 360.0f){
		fprintf(stderr, "RotationY = %f, decrementing with 360.\n", rotationY);
		rotationY -= 360.0f;
	}
	//rotationX += 0.005f;
	/*if (rotationX > 360.0f){
		fprintf(stderr, "RotationX = %f, decrementing with 360.\n", rotationX);
		rotationX -= 360.0f;
	}*/
	
	ctxt->perspective(60.0, GLfloat(WIN_WIDTH)/GLfloat(WIN_HEIGHT), 1.0f, 200.0f);
	//ctxt->perspective(20.0, GLfloat(WIN_WIDTH)/GLfloat(WIN_HEIGHT), 1.0f, 200.0f);
	tree->reset();

	tree->rotate(rotationY, Y_AXIS);
	//tree->rotate(-50, Y_AXIS);
	tree->translate(0.0f, -45.0f, -85.0f);
	//tree->translate(0.0f, -50.0f, -100.0f);
	//tree->translate(0.0f, -70.0f, -50.0f);
	checkError("draw 1");
	
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	checkError("draw 2");

    tree->draw(ctxt);
	checkError("draw 3");

	glFlush();
	glutSwapBuffers();
}

bool initGlew(void)
{
	glewExperimental = GL_TRUE;
	checkError("init 0");
	GLenum err = glewInit();
	checkError("init 1");
	if (GLEW_OK != err)
	{
		fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
		return GL_FALSE;
	} else {
		fprintf(stderr, "GLEW is initialized!\n");
	}
	if (!glewIsSupported("GL_VERSION_3_1"))
	{
		fprintf(stderr, "Warning: Repported no support for OpenGL 3.1!\n");
		if (!glewIsSupported("GL_VERSION_3_0"))
		{
			fprintf(stderr, "Error: Repported no support for OpenGL 3.0!\n");
			return GL_FALSE;		
		} else {
			fprintf(stderr, "Continuing with support for OpenGL 3.0...\n");
		}
	} else {
		fprintf(stderr, "We have OpenGL 3.1!\n");
	}
	fprintf(stdout, "Status: Using GLEW %s\n", glewGetString(GLEW_VERSION));
	return GL_TRUE;


}

void finish(void)
{
	//glDeleteBuffers(NUM_BUFS, buffernames);
	//shutdown();

}

void keyboard(unsigned char key, int x, int y)
{
   switch (key) {
      case 27:
         exit(0);
         break;
   }
}

void mouse(int button, int state, int x, int y)
{
	switch (button) {
		case GLUT_LEFT_BUTTON:
			if (state == GLUT_DOWN)
				fprintf(stderr, "Left-clicked (%d, %d).\n",x,y);
			break;
		case GLUT_RIGHT_BUTTON:
			if (state == GLUT_DOWN)
				fprintf(stderr, "Right-clicked (%d, %d).\n",x,y);
			break;
		default:
			break;
	}

	
}


int _tmain(int argc, _TCHAR* argv[])
//int main(int argc, char** pargv)
{	
	char* str = "TreeFire";
	char* pargv[2];
	pargv[0] = str;

	std::cout << "Initializing GLUT..." << std::endl;
	glutInit(&argc, pargv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);//GLUT_SINGLE);
	glutInitWindowSize(WIN_HEIGHT, WIN_WIDTH);
	glutInitWindowPosition(100, 100);
	glutInitContextVersion(3, OPENGL_MINOR_VERSION);
	glutInitContextFlags(GLUT_FORWARD_COMPATIBLE);
	glutCreateWindow(pargv[0]);

	std::cout << "Initializing GLEW..." << std::endl;
	initGlew();

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    glViewport(0, 0, WIN_WIDTH, WIN_HEIGHT);

	//const char* objFileName = "sample_objfiles\\jorgenhires_uniq.obj";
	//const GLfloat scale = 4.0;
	const char* objFileName = "sample_objfiles\\jorgenlores_uniq.obj";
	const GLfloat scale = 5.0;
	std::cout << "Reading obj file '" << objFileName << "'..." << std::endl;
	//cube.loadData(cubeVertices, 8, cubevIndices, \
	//	cubeColors, 6, cubecIndices, 36, GL_TRIANGLES);
	//cube.loadData2(cubeVerticesAndColors, 8, 2, cubeIndices, 72, GL_TRIANGLES);
	//cube.loadData(cubeVertices, cubeNormals, cubeColors, cubeIndices, cubeCounts);
	//cube.loadDataFromObj("sample_objfiles\\jtreesimple.obj", 1000000, 1000, 5.0);
	ObjData obj(objFileName, scale, true);
	obj.checkNormals();

	std::cout << "Creating simulation mesh..." << std::endl;
	Mesh simMesh(obj.getNumNodes(), obj.getNeighbourMatrix(), obj.getMaxNbors(),
		obj.getDistanceMatrix(), obj.getLinkdirMatrix(), obj.getVertexNodeMap(), obj.getNborCounts(), obj.getNodeFuels());
	simMesh.setUniformTemperatures(2.0); //set all temperatures to two
	simMesh.setSingleTemperature(50, 1000000.0); //ignite at node 0

	std::cout << "Initializing tree object..." << std::endl;
	tree = new BurningObject(
		obj.getVertPositions(),obj.getVertNormals(),obj.getVertColors(),obj.getVertTexcoords(), 
		obj.getVertDisplacements(), obj.getFaces(), obj.getNumVertices(), 
		obj.getNumFaces()*obj.getNumVertsPrFace(), "shader1.vert", "shader1.frag", "sample_objfiles\\bark3mork1.png", &simMesh);
	tree->updateWind(0.5,0.7,0.0);

	ctxt = new RenderContext();
	ctxt->setClearColor(1.0f, 1.0f, 1.0f, 0.0f); // white background (default is black)
	glutDisplayFunc(display);
	glutIdleFunc(display);
	//glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);
	std::cout << "Entering main loop..." << std::endl;
	glutMainLoop();
	delete tree;
	return 0;
}

