#pragma once
#define EMPTY_MATRIX4  { 0.0, 0.0, 0.0, 0.0,\
                         0.0, 0.0, 0.0, 0.0,\
                         0.0, 0.0, 0.0, 0.0,\
                         0.0, 0.0, 0.0, 0.0 }

#define IDENTITY_MATRIX4 { 1.0, 0.0, 0.0, 0.0,\
                           0.0, 1.0, 0.0, 0.0,\
                           0.0, 0.0, 1.0, 0.0,\
                           0.0, 0.0, 0.0, 1.0 }

typedef enum {
X_AXIS,
Y_AXIS,
Z_AXIS
} AXIS;

//NB: Must be of homogeneus type (e.g. all GLfloat)!
// Hopefully, this will prevent padding (http://c-faq.com/struct/padding.html)
struct Vec2f {
	GLfloat x;
	GLfloat y;
};
struct Vec3f {
	GLfloat x;
	GLfloat y;
	GLfloat z;
};
struct Vec4f {
	GLfloat x;
	GLfloat y;
	GLfloat z;
	GLfloat w;
};



#define BUFFER_OFFSET(bytes) ((GLubyte*) NULL + (bytes))

#define PI_OVER_360 0.00872664626f
#define PI_OVER_180 0.0174532925199f

/* Multiply 4x4 matrix m1 by 4x4 matrix m2 and store the result in m1 */
void multiply4x4(GLfloat *m1, GLfloat *m2);
GLboolean inverse(const GLfloat theMatrix[3][3], GLfloat theOutput[3][3]);
void transpose(GLfloat a[3][3], GLfloat b[3][3]);

int checkError(const char *GLcall);
void multiply4x4(GLfloat *m1, GLfloat *m2);
GLboolean vec3Equal(Vec3f u, Vec3f v, GLfloat epsilon);
void initShaderProgram(void);
inline void loadIdMatrix4x4f(GLfloat* m){
	memset(m, 0, 16*sizeof(GLfloat));
    m[0] = 1.0f;
    m[5] = 1.0f;
    m[10] = 1.0f;
    m[15] = 1.0f;
}
GLchar* readFile(const GLchar* filename, long maxlength);
void loadFile(std::vector<unsigned char>& buffer, const std::string& filename);
void printMatrix3(const char* name, const GLfloat m[3][3]);
void printMatrix16(const char* name, const GLfloat m[16]);

void pausePressEnter();
void printVec3f(Vec3f* vec);

/*
inline GLfloat stringToFloat(const std::string& s)
{
	std::istringstream i(s);
	GLfloat x;
	if (!(i >> x))
	{
		std::cout << "ERROR when converting '" << s << "' to float." << std::endl;
		x=0.0;
	}
	return x;
}

inline Vec3f vec3sToVec3f(const Vec3s& s)
{
	Vec3f f;
	f.x = stringToFloat(s.x);
	f.y = stringToFloat(s.y);
	f.z = stringToFloat(s.z);
	return f;
}
*/

